// DrawAndDrawDoc.h : interface of the CDrawAndDrawDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DRAWANDDRAWDOC_H__B94E5272_63FA_11D6_9EE7_CD2745F07739__INCLUDED_)
#define AFX_DRAWANDDRAWDOC_H__B94E5272_63FA_11D6_9EE7_CD2745F07739__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CDrawAndDrawDoc : public CDocument
{

public: // create from serialization only
	CDrawAndDrawDoc();
	DECLARE_DYNCREATE(CDrawAndDrawDoc)

// Attributes
//private:
public:
    int         m_cx;
    int         m_cy;

    BOOL        m_bOpenEdge;
    CByteArray  m_byGrid;
    CByteArray  m_byBuffer;

    void    SetBackgroundCell (int nRow, int nCol, BOOL bState);
// Operations
public:
   
    CSize   GetGridSize ();
    BOOL    GetCell (int, int);
    BOOL    ToggleCell (int, int);
    int     Evolve ();  

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDrawAndDrawDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDrawAndDrawDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDrawAndDrawDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DRAWANDDRAWDOC_H__B94E5272_63FA_11D6_9EE7_CD2745F07739__INCLUDED_)
